unit hiSDialog;

interface

uses Kol,Share,Debug;

type
  THISDialog = class(TDebug)
   private
    FSaveDialog:POpenSaveDialog;
   public
    _prop_StartDir:string;
    _prop_Filter:string;
    _prop_Title:string;
    _prop_Filename:string;
    _data_StartDir:THI_Event;
    _data_Filename:THI_Event;
    _event_onExecute:THI_Event;
    _event_onCancel:THI_Event;

    procedure _work_doExecute(var _Data:TData; Index:word);
    procedure _work_doStartDir(var _Data:TData; Index:word);
  end;

implementation

procedure THISDialog._work_doExecute;
begin
  if not Assigned(FSaveDialog) then
    begin
      FSaveDialog := NewOpenSaveDialog(_prop_Title,_prop_StartDir,[]);
      FSaveDialog.Filter := _prop_Filter;
      FSaveDialog.OpenDialog := false;
      FSaveDialog.WndOwner := ReadHandle;
      FSaveDialog.filename :=ReadString(_Data,_data_FileName,_prop_filename);
    end;
  if FSaveDialog.Execute then
   _hi_OnEvent(_event_onExecute,FSaveDialog.filename)
  else _hi_OnEvent(_event_onCancel);
end;

procedure THISDialog._work_doStartDir;
begin
   _prop_StartDir := ReadString(_Data,_data_StartDir,_prop_StartDir);
end;

end.
